<?php
/**
 * Created by PhpStorm.
 * User: tomaskircher
 * Date: 2018-01-24
 * Time: 19:46
 */

namespace includes\utils;

require( WTV_PATH . '/vendor/autoload.php');

use GuzzleHttp\Client;

class WTV_Currency_Converter
{
    const FIXER_URL = 'http://data.fixer.io/api/';
    const FIXER_API_ACCES_KEY = 'fa27cb84d9368707ea3ac6f7b9815e0c';

    private $rates;

    public function __construct( $from_currency, $date ){
        $this->from_currency = $from_currency;
        $this->date = date('Y-m-d', strtotime( $date ) );

        if ( 'SEK' != $this->from_currency ) {
            $cached_rates = get_transient( $this->from_currency . '_' . $this->date );
            if ( ! $cached_rates ) {
                $this->get_rates();
            }
            else{
                $this->rates = $cached_rates;
            }
        }

    }

    private function get_rates(){
        $client = new Client( ['base_uri' => self::FIXER_URL ]);

        $options = array(
            'http_errors' => false
        );

        $response = $client->get(  $this->date . '?from=' . $this->from_currency . '&access_key=' . self::FIXER_API_ACCES_KEY, $options );

        $data = json_decode( $response->getBody(), true );

        $this->rates = $data['rates'];
        set_transient( $this->from_currency . '_' . $this->date, $this->rates, 60*60*400 );
    }

    public function convert( $amount ){

        if ( 'SEK' == $this->from_currency ){
            return WTV_Utils::format_number( $amount );
        }
        $amount_in_eur = $amount / $this->rates[$this->from_currency];
        $amount_in_sek = $amount_in_eur * $this->rates['SEK'];
        return WTV_Utils::format_number( $amount_in_sek );
    }
}