<?php
/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2017-07-04
 * Time: 11:13
 */

namespace includes\utils;

use WC_Countries;

class WTV_Utils
{

    /**
     * Returns true if country_code is EU
     *
     * @param string $country_code
     * @return bool
     */
    public static function is_outside_eu( $country_code ) {
        $countries = new WC_Countries();
        if ( $country_code == 'SE' || in_array( $country_code, $countries->get_european_union_countries() ) ) {
            return false;
        }
        return true;
    }

    /**
     * Returns tax rates
     * @param \WC_Product $product
     * @param $country_code
     * @return int
     */
    public static function get_wc_tax_rate( $product, $country_code ){

        foreach( \WC_Tax::get_rates_for_tax_class( $product->get_tax_class() ) as $tax_rate){
            if ( $country_code == $tax_rate->tax_rate_country ){
                return $tax_rate->tax_rate;
            }
        }

        foreach( \WC_Tax::get_rates_for_tax_class( $product->get_tax_class() ) as $tax_rate){

            if( '' == $tax_rate->tax_rate_country ){
                return $tax_rate->tax_rate;
            }
        }
        return 0;
    }

    /**
     * @param $option
     * @param $needed
     * @return string
     */
    public static function setting_needed( $option, $needed ){
        if( $needed ){
            $setting = get_option( $option );
            if ( empty( $setting ) ) {
                return false;
            }
        }
        return true;

    }

    /**
     * Numberformatting function
     * @param $amount
     * @return string
     */
    public static function format_number( $amount ){
        return number_format( floatval( $amount ), 2 ,  "." , $thousands_sep = "" );
    }

}