<?php

namespace includes\views;

use includes\wetail\admin\WTV_Settings;
use includes\WTV_Plugin;

/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:25
 */

class WTV_Bulk_Actions_View
{

    /**
     * Renders settings for Bulk actions
     */
    public static function render_settings(){

        $page = 'visma';

        WTV_Settings::add_tab([
            'page' => $page,
            'name' => 'bulk-actions',
            'title' => __('Bulk actions', WTV_Plugin::TEXTDOMAIN),
            'saveButton' => false
        ]);

        WTV_Settings::add_section([
            'page' => $page,
            'tab' => 'bulk-actions',
            'name' => 'bulk-actions',
            'title' => __('Bulk actions', WTV_Plugin::TEXTDOMAIN),
            'description' => __('Useful bulk actions to perform retroactively between WooCommerce and Visma.', WTV_Plugin::TEXTDOMAIN)
        ]);

        WTV_Settings::add_field([
            'page' => $page,
            'tab' => 'bulk-actions',
            'section' => 'bulk-actions',
            'title' => __('Sync products', WTV_Plugin::TEXTDOMAIN),
            'type' => 'button',
            'button' => [
                'text' => __('Sync products', WTV_Plugin::TEXTDOMAIN),
            ],
            'data' => [
                [
                    'key' => 'visma-bulk-action',
                    'value' => 'visma_sync_products'
                ]
            ],
            'description' => __('Upload all products from WooCommerce to Visma. It may take a while to synchronise large shops.', WTV_Plugin::TEXTDOMAIN)
        ]);

        WTV_Settings::add_field([
            'page' => $page,
            'tab' => 'bulk-actions',
            'section' => 'bulk-actions',
            'title' => __('Sync inventory', WTV_Plugin::TEXTDOMAIN),
            'type' => 'button',
            'button' => [
                'text' => __('Sync inventory', WTV_Plugin::TEXTDOMAIN),
            ],
            'data' => [
                [
                    'key' => 'visma-bulk-action',
                    'value' => 'visma_sync_inventory'
                ]
            ],
            'description' => __('Update stock status from Visma. It may take a while to synchronise large shops.', WTV_Plugin::TEXTDOMAIN)
        ]);

        WTV_Settings::add_field([
            'page' => $page,
            'tab' => 'bulk-actions',
            'section' => 'bulk-actions',
            'title' => __('Find missing products', WTV_Plugin::TEXTDOMAIN),
            'type' => 'button',
            'button' => [
                'text' => __('Find missing products', WTV_Plugin::TEXTDOMAIN),
            ],
            'data' => [
                [
                    'key' => 'visma-bulk-action',
                    'value' => 'visma_find_missing_products'
                ]
            ],
            'description' => __('Get a list of missing products in Visma.', WTV_Plugin::TEXTDOMAIN) . '</span><div class="visma-missing-products-list"></div><span></span>'
        ]);

        WTV_Settings::add_field([
            'page' => $page,
            'tab' => 'bulk-actions',
            'section' => 'bulk-actions',
            'title' => __('Sync all unsynchronized products to Visma', WTV_Plugin::TEXTDOMAIN),
            'type' => 'button',
            'button' => [
                'text' => __('Sync all unsynchr. products', WTV_Plugin::TEXTDOMAIN),
            ],
            'data' => [
                [
                    'key' => 'visma-bulk-action',
                    'value' => 'visma_sync_all_products'
                ]
            ],
            'description' => __('Sync all unsynchronized products to Visma.', WTV_Plugin::TEXTDOMAIN) . '</span><div class="visma-missing-products-list"></div><span></span>'
        ]);
    }
}