<?php

namespace includes\views;

use includes\wetail\admin\WTV_Settings;
use includes\WTV_Plugin;

/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:25
 */

class WTV_General_Settings_View{
    /**
     * Renders settings for general tab
     */
    public static function render_settings(){
        $page = 'visma';

        WTV_Settings::add_tab( [
            'page' => $page,
            'name' => 'general',
            'title'=> __( 'Allmänt', WTV_Plugin::TEXTDOMAIN )
        ] );

        WTV_Settings::add_section( [
            'page'          => $page,
            'tab'           => 'general',
            'name'          => 'license',
            'title'         => __( '', WTV_Plugin::TEXTDOMAIN ),
            'description'   => __( '', WTV_Plugin::TEXTDOMAIN )
        ] );

        WTV_Settings::add_field( [
            'page'          => $page,
            'tab'           => 'general',
            'section'       => 'license',
            'type'          => 'checkboxes',
            'title'         => __( 'Logg', WTV_Plugin::TEXTDOMAIN ),
            'options'   => [
                [
                    'name'  => 'visma_debug_log',
                    'label' => __( 'Aktivera loggfil', WTV_Plugin::TEXTDOMAIN )
                ],
                [
                    'name'  => 'visma_test',
                    'label' => __( 'Testmode', WTV_Plugin::TEXTDOMAIN )
                ]
            ]
        ] );

        WTV_Settings::add_field( [
            'page'      => $page,
            'tab'       => 'general',
            'section'   => 'license',
            'name'      => 'wetail_license_key',
            'title'     => __( 'Licensnyckel', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_section( [
            'page'  => $page,
            'tab'   => 'general',
            'name'  => 'settings',
            'title' => __( 'Visma', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_field( [
            'page'      => $page,
            'tab'       => 'general',
            'section'   => 'settings',
            'title'     => __( '', WTV_Plugin::TEXTDOMAIN ),
            'type'      => 'button',
            'button'    => [
                'text'      => __( 'Logga in', WTV_Plugin::TEXTDOMAIN ),
            ],
            'data'      => [
                [
                    'key'   => 'visma-admin-action',
                    'value' => 'visma_get_auth_url'
                ]
            ],
        ] );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'general',
            'section' => 'settings',
            'title' => __( '', WTV_Plugin::TEXTDOMAIN ),
            'type' => 'button',
            'button' => [
                'text' => __( 'Hämta inst. från Visma', WTV_Plugin::TEXTDOMAIN ),
            ],
            'data' => [
                [
                    'key' => 'visma-admin-action',
                    'value' => 'visma_update_settings'
                ]
            ],
        ] );
    }
}