<?php

namespace includes\views;

use includes\utils\WTV_Utils;
use includes\wetail\admin\WTV_Settings;
use includes\WTV_Plugin;
use includes\WTV_Settings_Validator;

/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:25
 */

class WTV_Product_Settings_View{

    public static function render_settings(){

        $valid = WTV_Settings_Validator::product_settings_are_valid();
        $country_settings = WTV_Settings_Validator::get_country_settings();
        $tax_settings = WTV_Settings_Validator::get_tax_settings();
        $page = 'visma';

        WTV_Settings::add_tab( [
            'page' => $page,
            'name' => 'products',
            'title' => __( 'Produktinställningar', WTV_Plugin::TEXTDOMAIN ),
        ], $valid );

        WTV_Settings::add_section( [
            'page' => $page,
            'tab' => 'products',
            'name' => 'preferences',
            'title' => __( 'Allmänt', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'preferences',
            'type' => 'checkboxes',
            'options' => [
                [
                    'name' => 'visma_do_not_sync_price',
                    'label' => __( 'Uppdatera ej pris vid ordersynk', WTV_Plugin::TEXTDOMAIN )
                ],
                [
                    'name' => 'visma_auto_generate_sku',
                    'label' => __( 'Skapa ett SKU automatiskt för produkter som saknar SKU', WTV_Plugin::TEXTDOMAIN )
                ],
                [
                    'name' => 'visma_auto_sync_products',
                    'label' => __( 'Synkronisera produkter automatiskt', WTV_Plugin::TEXTDOMAIN )
                ],
                [
                    'name' => 'visma_sync_master_product',
                    'label' => __( 'Synkronisera förälderprodukt', WTV_Plugin::TEXTDOMAIN )
                ],
                [
                    'name' => 'visma_skip_product_variations',
                    'label' => __( 'Synkronisera ej variationer', WTV_Plugin::TEXTDOMAIN )
                ]
            ]
        ] );

        WTV_Settings::add_section( [
            'page' => $page,
            'tab' => 'products',
            'name' => 'accounting',
            'title' => __( 'Bokföring', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_domestic_vat_25_account',
            'title' => __( 'Konto, utgående moms 25% Sverige', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_domestic_vat_25_account', $country_settings['sells_to_se'] && $tax_settings['25'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_domestic_vat_12_account',
            'title' => __( 'Konto, utgående moms 12% Sverige', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_domestic_vat_12_account', $country_settings['sells_to_se'] && $tax_settings['12'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_domestic_vat_6_account',
            'title' => __( 'Konto, utgående moms 6% Sverige', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_domestic_vat_6_account', $country_settings['sells_to_se'] && $tax_settings['6'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_eu_vat_25_account',
            'title' => __( 'Konto, utgående moms 25% EU', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_eu_vat_25_account', $country_settings['sells_to_eu'] && $tax_settings['25'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_eu_vat_12_account',
            'title' => __( 'Konto, utgående moms 12% EU', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_eu_vat_12_account', $country_settings['sells_to_eu'] && $tax_settings['12'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'products',
            'section' => 'accounting',
            'name' => 'visma_eu_vat_6_account',
            'title' => __( 'Konto, utgående moms 6% EU', WTV_Plugin::TEXTDOMAIN ),
        ], WTV_Utils::setting_needed( 'visma_eu_vat_6_account', $country_settings['sells_to_eu'] && $tax_settings['6'] ) );
    }
}