<?php

namespace includes\views;

use includes\utils\WTV_Utils;
use includes\wetail\admin\WTV_Settings;
use includes\WTV_Plugin;
use includes\WTV_Settings_Validator;
use WC_Shipping_Zones;

/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:25
 */

class WTV_Shipping_Settings_View
{

    public static function render_settings()
    {
        $valid = WTV_Settings_Validator::shipping_settings_are_valid();
        $country_settings = WTV_Settings_Validator::get_country_settings();
        $page = 'visma';

        WTV_Settings::add_tab([
            'page' => $page,
            'name' => 'shipping',
            'title' => __('Fraktinställningar', WTV_Plugin::TEXTDOMAIN),
        ], $valid );

        WTV_Settings::add_section( [
            'page' => $page,
            'tab' => 'shipping',
            'name' => 'shipping_accounts',
            'title' => __( 'Bokföring', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'shipping',
            'section' => 'shipping_accounts',
            'name' => 'visma_shipping_account_se',
            'title' => __( 'Konto för frakt inom Sverige', WTV_Plugin::TEXTDOMAIN ),
            'description' => $country_settings['sells_to_se'] ? self::get_description( 'visma_shipping_account_se' ) : '',
        ], WTV_Utils::setting_needed( 'visma_shipping_account_se', $country_settings['sells_to_se'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'shipping',
            'section' => 'shipping_accounts',
            'name' => 'visma_shipping_account_eu',
            'title' => __( 'Konto för frakt, EU', WTV_Plugin::TEXTDOMAIN ),
            'description' => $country_settings['sells_to_eu'] ? self::get_description( 'visma_shipping_account_eu' ) : '',
        ], WTV_Utils::setting_needed( 'visma_shipping_account_eu', $country_settings['sells_to_eu'] ) );

        WTV_Settings::add_field( [
            'page' => $page,
            'tab' => 'shipping',
            'section' => 'shipping_accounts',
            'name' => 'visma_shipping_account_world',
            'title' => __( 'Konto för frakt, världen', WTV_Plugin::TEXTDOMAIN ),
            'description' => $country_settings['sells_to_world'] ? self::get_description( 'visma_shipping_account_world' ) : '',
        ], WTV_Utils::setting_needed( 'visma_shipping_account_world', $country_settings['sells_to_world'] ) );

    }

    /**
     * @param $option
     * @return string
     */
    public static function get_description( $option ){
        $descriptions = array(
            'visma_shipping_account_se'     => __( 'I dina inställningar ser vi att du levererar till Sverige , detta bokföringskonto behövs då. Vanligt fraktkonto är 3520', WTV_Plugin::TEXTDOMAIN ),
            'visma_shipping_account_eu'     => __( 'I dina inställningar ser vi att du levererar till EU, detta bokföringskonto behövs då. Vanligt fraktkonto är 3521', WTV_Plugin::TEXTDOMAIN ),
            'visma_shipping_account_world'  => __( 'I dina inställningar ser vi att du levererar till resten av världen, detta bokföringskonto behövs då', WTV_Plugin::TEXTDOMAIN ),
        );

        return $descriptions[$option];

    }
}
