<?php
/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:30
 */

namespace includes\views;

use includes\wetail\admin\WTV_Settings;
use includes\WTV_Plugin;
use includes\WTV_Settings_Validator;

/**
 * Created by PhpStorm.
 * User: tomas
 * Date: 2018-01-10
 * Time: 09:25
 */

class WTV_Sync_Settings_View{

    const VOUCHER_SERIES_CHOICES = [
        [
            'id' => 1000,
            'name' => 'Bokför ej',
        ],
        [
            'id' => 1,
            'name' => 'A',
        ],
        [
            'id' => 2,
            'name' => 'B',
        ],
        [
            'id' => 3,
            'name' => 'C',
        ],
        [
            'id' => 4,
            'name' => 'D',
        ],
        [
            'id' => 5,
            'name' => 'E',
        ],
        [
            'id' => 6,
            'name' => 'F',
        ],
        [
            'id' => 7,
            'name' => 'G',
        ],
        [
            'id' => 8,
            'name' => 'H',
        ],
        [
            'id' => 9,
            'name' => 'I',
        ],
        [
            'id' => 10,
            'name' => 'J',
        ],
        [
            'id' => 11,
            'name' => 'K',
        ],
        [
            'id' => 12,
            'name' => 'L',
        ],
        [
            'id' => 13,
            'name' => 'M',
        ],
        [
            'id' => 14,
            'name' => 'N',
        ],
        [
            'id' => 15,
            'name' => 'O',
        ],
        [
            'id' => 16,
            'name' => 'P',
        ],
        [
            'id' => 17,
            'name' => 'Q',
        ],
        [
            'id' => 18,
            'name' => 'R',
        ],
        [
            'id' => 19,
            'name' => 'S',
        ],
        [
            'id' => 20,
            'name' => 'T',
        ],
        [
            'id' => 21,
            'name' => 'U',
        ],
        [
            'id' => 22,
            'name' => 'V',
        ],
    ];

    const visma_order_statuses = [
        [
            'id' => 1,
            'name' => 'Utkast',
        ],
        [
            'id' => 2,
            'name' => 'Pågående',
        ],
        [
            'id' => 3,
            'name' => 'Skickad',
        ],
    ];

    /**
     * Renders settings for order tab
     */
    public static function render_settings(){

        $valid = WTV_Settings_Validator::order_settings_are_valid();
        $page = 'visma';

        WTV_Settings::add_tab( [
            'page' => $page,
            'name' => 'sync',
            'title' => __( 'Synkronisering', WTV_Plugin::TEXTDOMAIN )
        ], $valid );

        WTV_Settings::add_section( [
            'page' => $page,
            'tab' => 'sync',
            'name' => 'sync_order',
            'title' => __( 'Synkronisera ordrar', WTV_Plugin::TEXTDOMAIN ),
        ] );

        WTV_Settings::add_field( [
            'page'          => $page,
            'tab'           => 'sync',
            'section'       => 'sync_order',
            'type'          => 'checkboxes',

            'options'   => [
                [
                    'name'  => 'visma_sync_orders',
                    'label' => __( 'Skapar ordrar i Visma', WTV_Plugin::TEXTDOMAIN )
                ]
            ]
        ] );

        WTV_Settings::add_section( [
            'page' => $page,
            'tab' => 'sync',
            'name' => 'payments',
            'title' => __( 'Betalsätt', WTV_Plugin::TEXTDOMAIN ),
        ] );

        if( get_option('visma_sync_orders') ){
            foreach( WC()->payment_gateways->get_available_payment_gateways() as $payment_method) {

                WTV_Settings::add_field( [
                    'page'          => $page,
                    'tab'           => 'sync',
                    'section'       => 'payments',
                    'title'         => $payment_method->title,
                    'type'          => 'table',
                    'name'          => 'visma_order_sync_settings_' . $payment_method->id,
                    'description'   => '',
                    'table'     => [
                        'table'     => [
                            'id'        => 'visma-order-sync-settings',
                            'columns'   => [
                                [
                                    'column' => [
                                        'name' => 'sync_on_status',
                                        'title' => __( 'Synkronisera på status', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'payment_account',
                                        'title' => __( 'Bokföringskonto', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'voucher_series',
                                        'title' => __( 'Verifikationsserie', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'terms_of_payment_id',
                                        'title' => __( 'Order: Betalvillkor', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'order_status',
                                        'title' => __( 'Order: Sätt till status i Visma', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                            ],
                            'rows'      => self::get_payment_method_settings( $payment_method->id ),
                        ]
                    ],
                ] );
            }
        }
        else{
            foreach( WC()->payment_gateways->get_available_payment_gateways() as $payment_method) {

                WTV_Settings::add_field( [
                    'page'          => $page,
                    'tab'           => 'sync',
                    'section'       => 'payments',
                    'title'         => $payment_method->title,
                    'type'          => 'table',
                    'name'          => 'visma_order_sync_settings_' . $payment_method->id,
                    'table'     => [
                        'table'     => [
                            'id'        => 'visma-order-sync-settings',
                            'columns'   => [
                                [
                                    'column' => [
                                        'name' => 'sync_on_status',
                                        'title' => __( 'Synkronisera på status', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'payment_account',
                                        'title' => __( 'Bokföringskonto', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ],
                                [
                                    'column' => [
                                        'name' => 'voucher_series',
                                        'title' => __( 'Verifikationsserie', WTV_Plugin::TEXTDOMAIN )
                                    ]
                                ]
                            ],
                            'rows'      => self::get_payment_method_settings( $payment_method->id ),
                        ]
                    ],
                ] );
            }
        }

        WTV_Settings::add_section( [
            'page'  => $page,
            'tab'   => 'sync',
            'name'  => 'preferences',
            'title' => __( 'Övrigt', WTV_Plugin::TEXTDOMAIN )
        ] );

        WTV_Settings::add_field( [
            'page'      => $page,
            'tab'       => 'sync',
            'section'   => 'preferences',
            'type'      => 'checkboxes',
            'options'   => [
                [
                    'name'  => 'visma_credit_voucher_on_refund',
                    'label' => __( 'Skapa krediteringverifikation när order krediterats', WTV_Plugin::TEXTDOMAIN )
                ]
            ]
        ] );

        if( ! is_plugin_active( 'woocommerce-sequential-order-numbers-pro/woocommerce-sequential-order-numbers.php' ) ) {
            WTV_Settings::add_field( [
                'page'          => $page,
                'tab'           => 'sync',
                'section'       => 'preferences',
                'name'          => 'visma_order_number_prefix',
                'type'          => 'text',
                'title'         => __( 'Sekventiellt ordernummer', WTV_Plugin::TEXTDOMAIN ),
                'description'   => __( 'Sekventiellt ordernummer som adderas till WooCommerce ordernummer vid synk.', WTV_Plugin::TEXTDOMAIN )
            ] );
        }

        WTV_Settings::add_field( [
            'page'          => $page,
            'tab'           => 'sync',
            'section'       => 'preferences',
            'type'          => 'checkbox',
            'name'          => 'visma_sync_existing_product',
            'label'         => __( 'Uppdatera exist. produkt i Visma vid ordersynkronisering', WTV_Plugin::TEXTDOMAIN )
        ] );

        WTV_Settings::add_field( [
            'page'          => $page,
            'tab'           => 'sync',
            'section'       => 'preferences',
            'type'          => 'checkbox',
            'name'          => 'show_organization_number_field_in_billing_address_form',
            'label'         => __( 'Visa organisationsnummerfält i kassan', WTV_Plugin::TEXTDOMAIN ),
        ] );

    }

    /**
     * Get payment method settings
     * @param string $payment_method_id
     * @return array
     */
    private static function get_payment_method_settings( $payment_method_id ){
        $settings = get_option( 'visma_order_sync_settings_' . $payment_method_id, [] );
        if( get_option('visma_sync_orders') ){
            return [
                'columns' => [
                    [
                        'column' => [
                            'name'      => 'sync_on_status',
                            'content'   => self::get_sync_on_status_dropdown( $payment_method_id, isset( $settings['sync_on_status'] ) ? $settings['sync_on_status'] : '')
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'payment_account',
                            'content'   => self::get_payment_account_dropdown( $payment_method_id, isset( $settings['payment_account'] ) ? $settings['payment_account'] : '' )
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'voucher_series',
                            'content'   => self::get_voucher_series_dropdown( $payment_method_id, isset( $settings['voucher_series'] ) ? $settings['voucher_series'] : '' )
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'terms_of_payment_id',
                            'content'   => self::get_terms_of_payment_dropdown( $payment_method_id, isset( $settings['terms_of_payment_id'] ) ? $settings['terms_of_payment_id'] : '' )
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'order_status',
                            'content'   => self::get_order_status_dropdown( $payment_method_id, isset( $settings['order_status'] ) ? $settings['order_status'] : '' )
                        ]
                    ]
                ]
            ];
        }
        else{
            return [
                'columns' => [
                    [
                        'column' => [
                            'name'      => 'sync_on_status',
                            'content'   => self::get_sync_on_status_dropdown( $payment_method_id, isset( $settings['sync_on_status'] ) ? $settings['sync_on_status'] : '')
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'payment_account',
                            'content'   => self::get_payment_account_dropdown( $payment_method_id, isset( $settings['payment_account'] ) ? $settings['payment_account'] : '' )
                        ]
                    ],
                    [
                        'column' => [
                            'name'      => 'voucher_series',
                            'content'   => self::get_voucher_series_dropdown( $payment_method_id, isset( $settings['voucher_series'] ) ? $settings['voucher_series'] : '' )
                        ]
                    ]
                ]
            ];
        }

    }

    /**
     * Get sync on status dropdown
     * @param string $payment_method_id
     * @param int $selected
     * @return string
     */
    public static function get_sync_on_status_dropdown( $payment_method_id, $selected ){

        $statuses = array();

        foreach ( wc_get_order_statuses() as $status => $title) {
            $statuses[] = array(
                'id'    => substr( $status, 3),
                'name'  => $title
            );
        }

        array_unshift( $statuses, [
            'id' => '',
            'name' => __( 'Välj...', WTV_Plugin::TEXTDOMAIN )
        ]);

        $options = array_map( function( $status ) use( $selected ) {
            $selected = ( $status['id'] == $selected ) ? ' selected="selected"' : '';

            return '<option value="' . $status['id'] . '"' . $selected . '>' . $status['name'] . '</option>';
        }, array_values( $statuses ) );

        return '<select name="visma_order_sync_settings_' . $payment_method_id . '[sync_on_status]"><option value=""></option>' . join( '', $options ) . '</select>';
    }

    /**
     * Get sync on voucher series dropdown
     * @param string $payment_method_id
     * @param int $selected
     * @return array
     */
    public static function get_voucher_series_dropdown( $payment_method_id,  $selected ){

        $options = array_map( function( $choice ) use( $selected ) {
            $selected = ( $choice['id'] == $selected ) ? ' selected="selected"' : '';

            return '<option value="' . $choice['id'] . '"' . $selected . '>' . $choice['name'] . '</option>';
        }, array_values( self::VOUCHER_SERIES_CHOICES ) );

        return '<select name="visma_order_sync_settings_' . $payment_method_id . '[voucher_series]"><option value=""></option>' . join( '', $options ) . '</select>';
    }

    /**
     * Get sync on order status dropdown
     * @param string $payment_method_id
     * @param int $selected
     * @return array
     */
    public static function get_order_status_dropdown( $payment_method_id, $selected ){

        $options = array_map( function( $order_status ) use( $selected ) {
            $selected = ( $order_status['id'] == $selected ) ? ' selected="selected"' : '';

            return '<option value="' . $order_status['id'] . '"' . $selected . '>' . $order_status['name'] . '</option>';
        }, array_values( self::visma_order_statuses ) );

        return '<select name="visma_order_sync_settings_' . $payment_method_id . '[order_status]"><option value=""></option>' . join( '', $options ) . '</select>';
    }

    /**
     * Get sync on terms of payment dropdown
     * @param string $payment_method_id
     * @param int $selected
     * @return array
     */
    public static function get_terms_of_payment_dropdown( $payment_method_id, $selected ){
        $terms_of_payments = get_option( 'visma_terms_of_payments', [] );

        array_unshift( $terms_of_payments, [
            'id' => '',
            'name' => __( 'Välj...', WTV_Plugin::TEXTDOMAIN )
        ]);

        $options = array_map( function( $term_of_payment ) use( $selected ) {
            $selected = ( $term_of_payment['id'] == $selected ) ? ' selected="selected"' : '';

            return '<option value="' . $term_of_payment['id'] . '"' . $selected . '>' . $term_of_payment['name'] . '</option>';
        }, array_values( $terms_of_payments ) );

        return '<select name="visma_order_sync_settings_' . $payment_method_id . '[terms_of_payment_id]"><option value=""></option>' . join( '', $options ) . '</select>';
    }

    /**
     * Get sync on payment_account dropdown
     * @param string $payment_method_id
     * @param int $selected
     * @return string
     */
    public static function get_payment_account_dropdown( $payment_method_id, $selected ){
        $payment_account_arr = [];
        $payment_accounts = get_option( 'visma_payment_accounts', [] );
        foreach ( $payment_accounts as $payment_account) {
            $payment_account_arr[] = [
                'number' => $payment_account
            ];
        }

        $options = array_map( function( $payment_account ) use( $selected ) {
            $selected = ( $payment_account['number'] == $selected ) ? ' selected="selected"' : '';

            return '<option value="' . $payment_account['number'] . '"' . $selected . '>' . $payment_account['number'] . '</option>';
        }, array_values( $payment_account_arr ) );

        return '<select name="visma_order_sync_settings_' . $payment_method_id . '[payment_account]"><option value=""></option>' . join( '', $options ) . '</select>';
    }
}
    